# Copyrights Kevin Trancho 2021
# Part of python3 demonstration for web and database handling

import sqlite3

from nameGenerator import *
from random import *

connexion = sqlite3.connect('database.db')

with open('schema.sql') as f:
	connexion.executescript(f.read())

cur = connexion.cursor()

sports = [
	'Athlétisme',
	'Aviron',
	'Biathlon',
	'Canoë',
	'Canoë-kayak',
	'Course à pied',
	'Cyclisme',
	'Karting',
	'Natation',
	'Triathlon',
	'VTT'
]

sportsRandomDistance = {
	'Athlétisme' : lambda : [800, 1500, 3000, 5000][randint(0, 3)] + randint(-300, 1000),
	'Aviron' : lambda : [500, 2000][randint(0, 1)] + randint(-200, 1000),
	'Biathlon' : lambda : 12500 + randint(-300, 1000),
	'Canoë' : lambda : int(boxMullerLaw(12.5, 2) * 1000),
	'Canoë-kayak' : lambda : int(boxMullerLaw(12.5, 2) * 1000),
	'Course à pied' : lambda : int(boxMullerLaw(15, 3.75) * 1000),
	'Cyclisme' : lambda : int(boxMullerLaw(60, 15) * 1000),
	'Karting' : lambda : int(boxMullerLaw(30, 7.5) * 1000),
	'Natation' : lambda : [200, 400, 800, 1600][randint(0, 3)] + randint(-100, 600),
	'Triathlon' : lambda : int(boxMullerLaw(60, 15) * 1000),
	'VTT' : lambda : int(boxMullerLaw(30, 7.5) * 1000)
}

sportsRandomTime = {
	'Athlétisme' : lambda d : (3.6 * d) / boxMullerLaw(15, 3),
	'Aviron' : lambda d : (3.6 * d) / boxMullerLaw(23, 3),
	'Biathlon' : lambda d : (3.6 * d) / boxMullerLaw(12, 3),
	'Canoë' : lambda d : (3.6 * d) / boxMullerLaw(5, 0.5),
	'Canoë-kayak' : lambda d : (3.6 * d) / boxMullerLaw(5, 0.5),
	'Course à pied' : lambda d : (3.6 * d) / boxMullerLaw(15, 3),
	'Cyclisme' : lambda d : (3.6 * d) / boxMullerLaw(45, 10),
	'Karting' : lambda d : (3.6 * d) / boxMullerLaw(70, 5),
	'Natation' : lambda d : (d) / boxMullerLaw(1.75, 0.35),
	'Triathlon' : lambda d : (3.6 * d) / boxMullerLaw(20, 3),
	'VTT' : lambda d : (3.6 * d) / boxMullerLaw(22.5, 3)
}

for s in sports :
	cur.execute("INSERT INTO sports (nom) VALUES (?)",
		(s,))

classes = [
	"BTS2 CG",
	"BTS2 SP3S",
	"BTS2 CI",
	"BTS2 MCO",
	"BTS1 CG",
	"BTS1 CI",
	"BTS1 SP3S",
	"BTS1 MCO",
	"Terminale STMG",
	"Terminale ST2S",
	"Terminale Pro GA",
	"Terminale Pro SPVL",
	"Terminale Pro Vente",
	"Terminale Pro ASSP",
	"Première STMG",
	"Première ST2S",
	"Première Pro GA",
	"Première Pro SPVL",
	"Première Pro Vente",
	"Première Pro ASSP",
	"Seconde Pro GA",
	"Seconde Pro SPVL",
	"Seconde Pro Vente",
	"Seconde Pro ASSP"
]

niveau = {
	"BTS2" : 2,
	"BTS1" : 1,
	"Terminale" : 0,
	"Première" : -1,
	"Seconde" : -2
}

for c in classes :
	n = randint(16, 26)
	cur.execute("INSERT INTO classe (nom, niveau) VALUES (?, ?)",
		(c, niveau[c.split()[0]]))
	classeData = connexion.execute('SELECT * FROM classe WHERE nom = ?',
		(c,)).fetchone()
	classeId = classeData[0]
	for i in range(n) :
		p = generatePerson()
		print(p)
		cur.execute("INSERT INTO users (nom, prenom, classeId) VALUES (?, ?, ?)",
			(p.lastName, p.firstName, classeId))

users = list(cur.execute("SELECT * FROM users"))
sc = dict()
for e in users :
	currentSports = list()
	n = randint(1, 3)
	while len(currentSports) < n :
		v = sports[randint(0, len(sports) - 1)]
		if v in currentSports : continue
		currentSports.append(v)
	n = randint(8, 32)
	coeffs = [boxMullerLaw(1, 0.125) for s in currentSports]
	sportsCoeffs = list(map(list, zip(currentSports, coeffs)))
	sc[e[0]] = sportsCoeffs
si = dict()
for s in sports :
	sId = connexion.execute('SELECT * FROM sports WHERE nom = ?',
			(s,)).fetchone()[0]
	si[s] = sId
	
n = randint(len(users) * 8, len(users) * 24)
print(n)
for k in range(n) :
	print(k, n)
	e = users[randint(0, len(users) - 1)]
	sportsCoeffs = sc[e[0]]
	print(e, sportsCoeffs, n)
	#for i in range(n):
	s = sportsCoeffs[randint(0, len(sportsCoeffs) - 1)]
	sId = si[s[0]]
	s[1] *= 1.0125
	d = sportsRandomDistance[s[0]]()
	t = int(sportsRandomTime[s[0]](d) / s[1])
	cur.execute("INSERT INTO activity (content, duree, distance, commentaire, userId, sportId) VALUES (?, ?, ?, ?, ?, ?)",
		("", t, d, "", e[0], sId))

connexion.commit()
connexion.close()