DROP TABLE IF EXISTS classe;

CREATE TABLE classe (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	nom TEXT NOT NULL,
	niveau INTEGER NOT NULL
);

DROP TABLE IF EXISTS sports;

CREATE TABLE sports (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	nom TEXT NOT NULL
);

DROP TABLE IF EXISTS users;

CREATE TABLE users (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	created TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
	nom TEXT NOT NULL,
	prenom TEXT NOT NULL,
	classeId INTEGER NOT NULL,
	FOREIGN KEY (classeId) REFERENCES classe(id)
);

DROP TABLE IF EXISTS activity;

CREATE TABLE activity (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	created TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
	content TEXT NOT NULL,
	duree INTEGER,
	distance INTEGER,
	commentaire TEXT,
	userId INTEGER NOT NULL,
	sportId INTEGER NOT NULL,
	FOREIGN KEY (userId) REFERENCES users(id),
	FOREIGN KEY (sportId) REFERENCES sports(id)
);